unit u_firemonkey_style;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Dialogs, FMX.Objects, FMX.Layouts,
  FMX.Memo, FMX.ExtCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    StyleBook1: TStyleBook;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Button3: TButton;
    Button4: TButton;
    OpenDialog1: TOpenDialog;
    load_style_: TButton;
    find_style_resource_: TButton;
    Rectangle1: TRectangle;
    Memo1: TMemo;
    Button6: TButton;
    assign_style_: TButton;
    Layout1: TLayout;
    Text1: TText;
    Rectangle2: TRectangle;
    procedure load_style_Click(Sender: TObject);
    procedure find_style_resource_Click(Sender: TObject);
    procedure OpenDialog1CanClose(Sender: TObject; var CanClose: Boolean);
    procedure assign_style_Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.fmx}

    procedure display(p_text: String);
      begin
        Form1.Memo1.Lines.Add(p_text);
      end; // display

    procedure TForm1.load_style_Click(Sender: TObject);
      begin
        if OpenDialog1.Execute
          then Application.StyleFileName := OpenDialog1.FileName;
      end; procedure TForm1.OpenDialog1CanClose(Sender: TObject; var CanClose: Boolean);
begin

end;

// load_style_Click

    procedure TForm1.assign_style_Click(Sender: TObject);
      begin
        Button3.StyleLookup:= 'Button2Style1';
      end; // assign_style_Click

    procedure TForm1.find_style_resource_Click(Sender: TObject);
      var l_c_rectangle_resource: TRectangle;
          l_c_ttext_resource: TText;
      begin
(*
l_c_ttext_resource := fmx.types.FindStyleResource('text');
if (l_c_ttext_resource <> nil) and (l_c_ttext_resource is TText) then
*)
        l_c_ttext_resource := Button1.FindStyleResource('text') as TText;
        if Assigned(l_c_ttext_resource)
          then begin
              display('found_resource text');
              l_c_ttext_resource.Fill.Color := TAlphaColors.Blueviolet;
            end;

        // r := Button4.FindStyleResource('Button2Style1') as TRectangle;
        l_c_rectangle_resource:= Button4.FindStyleResource('background') as TRectangle;
        if Assigned(l_c_rectangle_resource)
          then begin
              display('found_resource background');
              l_c_rectangle_resource.Fill.Color := TAlphaColors.Blue;
            end
          else display('not_found  background '+ Button4.StyleLookup);

      end; // find_style_resource_Click

end.
